/*
 * Copyright (C) 1999-2006 <a href="mailto:paschke@in.tum.de">Adrian Paschke</a>
 * 
 * The ECA Interpreter is part of the Rule Based Service Level Agreement (RBSLA)
 * framework, available at 
 * <a href=" http://ibis.in.tum.de/staff/paschke/rbsla/index.htm">RBSLA</a>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package rbsla.eca;

import java.util.Map;

import org.mandarax.kernel.ResultSet;

import org.apache.log4j.Logger;

import rbsla.wrapper.KnowledgeBaseWrapper;
import ws.prova.reference.ProvaResultSetImpl2;

/**
 * Executes a System Action. More Informations see System Time.
 * 
 * @author <A HREF="mailto:paschke@in.tum.de">Adrian Paschke</A>
 * @version 0.1 <1 Sept 2005>
 * @since 0.1
 */
public class SystemAction extends Action
{

    private String query;

    private static Logger logger = Logger.getLogger(ProvaAction.class);

    public SystemAction(String _query)
    {
        query = _query;
    }
    
    public String nameOfAction()
    {
    
        return query;
    }
	
	public void replace(Map vars) {}
	
	public Object clone() {
		return new SystemAction(query);
	}

    public ResultSet start(KnowledgeBaseWrapper wrapper)
    {

        try
        {
			System.out.println("System:    " + query);			
			return wrapper.consult(query);
            
        } catch (Exception ex)
        {
            logger.warn("", ex);
			return new ProvaResultSetImpl2();
        }
    }
	
	public String toXML(int intend) {
	        return null;
	    }


}